/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.TarjetaFidelidadDAO;
import com.rjconsultores.ventaboletos.entidad.TarjetaFidelidad;
import com.rjconsultores.ventaboletos.entidad.TarjetaFidelidadCuenta;
import com.rjconsultores.ventaboletos.service.TarjetaFidelidadService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Shiro
 */
@Service("tarjetaFidelidadService")
public class TarjetaFidelidadServiceImpl implements TarjetaFidelidadService {

    @Autowired
    private TarjetaFidelidadDAO fidelidadDAO;

    public List<TarjetaFidelidad> obtenerTodos() {
        return fidelidadDAO.obtenerTodos();
    }

    public TarjetaFidelidad obtenerID(Integer id) {
        return fidelidadDAO.obtenerID(id);
    }

    public TarjetaFidelidad obtenerNumTarjeta(Integer numTarjeta){
    	return fidelidadDAO.obtenerNumTarjeta(numTarjeta);
    }
    
    @Transactional
    public TarjetaFidelidad suscribir(TarjetaFidelidad entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return fidelidadDAO.suscribir(entidad);
    }

    @Transactional
    public TarjetaFidelidad actualizacion(TarjetaFidelidad entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return fidelidadDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(TarjetaFidelidad entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        fidelidadDAO.actualizacion(entidad);
    }

    public List<TarjetaFidelidadCuenta> obtenerCantDesc() {
        return fidelidadDAO.obtenerCantDesc();
    }

}
